
#ifndef BIMODALANGLE_H
#define BIMODALANGLE_H

#include "base.h"

class BimodalAngle : public Motion {
public:
    BimodalAngle(double, double, double, double, double, std::mt19937_64& );
    explicit BimodalAngle(std::mt19937_64&);

    void initialize() override;
    double jump() override;
    void setParameters(const std::unordered_map<std::string, double> &) override;
    [[nodiscard]] std::unordered_map<std::string, double> getParameters() const override;
    [[nodiscard]] std::string toString() const override;

protected:
    double m_angle1{0};
    double m_angle2{0};
    double m_prob{0};
    SphericalPos m_prev_pos{0., 0.};
};

#endif //BIMODALANGLE_H
