#ifndef RWSIM_IO_H
#define RWSIM_IO_H

#include <unordered_map>
#include <map>
#include <string>
#include <filesystem>
#include <vector>

#include "../motions/base.h"
#include "../times/base.h"

struct Arguments {
    std::string parameter_file{};
    bool ste = false;
    bool spectrum = false;
    std::string motion_type{};
    std::string distribution_type{};
    std::unordered_map<std::string, double> optional;
};

Arguments parse_args(int argc, char* argv[]);
std::pair<std::string, double> get_optional_parameter(std::vector<std::string>::const_iterator &it);
std::unordered_map<std::string, double> read_parameter(const std::filesystem::path&);

std::string make_directory(const Motion&, const Distribution&);

void save_parameter_to_file(const std::string&, const std::string&, const std::unordered_map<std::string, double>&, const std::unordered_map<std::string, double>&);
void save_data_to_file(const std::string&, const std::string&, const std::vector<double>&, const std::map<double, std::vector<double>>&, const std::unordered_map<std::string, double>&);
void save_data_to_file(const std::string&, const std::string&, const std::vector<double>&, const std::vector<double>&, const std::unordered_map<std::string, double>&);

#endif
